#!/usr/bin/perl -w
#
# Get TV listings for http://www.bleb.org/tv/, and generates Perl code
# containing the data.
#
# (c) Andrew Flegg 2000. Thanks to Graham Chapman for further work.

use strict;
use lib "/home/jaffa/bin/tv";
#use lib "/dcs/97/csube/tmp/tv";
use Telly;

my $LOOKING_FOR_FIRST = 0;
my $LOOKING_FOR_TIME  = 1;
my $LOOKING_FOR_TITLE = 2;
my $READING_DESC      = 3;

# -- Process each channel in a separate thread...
#
foreach my $i (keys(%Telly::CHANNELS)) {
    #next if ($i ne "bbc1mid");
    my $j     = $Telly::CHANNELS{$i};
    #my $child = fork();
    my $child = 0;

    if ($child == 0) {
	my $cmd = "$LYNX $BASE/$i.html";
	open(IN, "$cmd |") or die "getchannels: failed with $cmd\n";
	open(OUT, ">$DATA/$j.pm");
	if (! \*OUT) {
	    close(IN);
	    die "getchannels: couldn't write $j.dat\n";
	}

	#print "Processing $j...\n";
	my $date = scalar(localtime);
	print OUT <<EOH;
# Today's Telly information for $j
#
# Automatically generated at $date
# (c) Andrew Flegg 2000. All rights reserved.

my \@channel;
EOH

	# -- Process the input
        #
	my $status = $LOOKING_FOR_TIME;
        my $time   = "";
	my $title  = "";
	my $desc   = "";
	my $count  = 0;
	while (<IN>) {
	    if ($status == $LOOKING_FOR_TIME) {
		if (m!<b>(\d{1,2}\.\d{2}[ap]m)?</b>!i) {
		    # -- Found a new program
		    #
		    if ($1) {
			$time = time24($1);
		    } else {
			$time = "";
		    }
		    $title  = "";
		    $desc   = "";
		    $status = $LOOKING_FOR_TITLE;
		}
	    
	    } elsif ($status == $LOOKING_FOR_TITLE) {
		if (m!\s*<b>([^<>]+)</b>\s*$!i) {
		    # -- Got the title
		    #
		    $title  = $1;
		    $status = $READING_DESC;
		}

	    } elsif ($status == $READING_DESC) {
		if (m!^\s*(<[ib]>)?([^<>]*)(</[ib]>)?\s*$!i) {
		    # -- A new valid line of description
		    #
		    my $this = lc($1).$2.lc($3);
		    if ($this ne "") {
			$this =~ s/&/&amp;/g;
			$desc .= $this."\n";
		    }
		} elsif (m!</small></td></tr>!i) {
		    # -- End of record
		    #
		    $desc = quotemeta($desc);
		    print OUT "\$channel[$count]\t= [\"$time\",\n".
			      "         \t  \"$title\",\n".
			      "         \t  \"$desc\"];\n";
		    $status = $LOOKING_FOR_TIME;
		    $count++;
		}
	    }
	}

	print OUT "\n\n\$Telly::LISTINGS{'$j'} = \\\@channel;\n1;\n";
	close(OUT);
	close(IN);
    }
}

exit;


