#!/usr/bin/perl -w
#
# Output a particular channel's details in full
# (c) Andrew Flegg 2000. Released under the Artistic Licence
# http://www.opensource.org/licenses/artistic-license.html

use strict;
use CGI;
use POSIX qw(strftime);
use lib "/home/jaffa/bin/tv";
use Telly;

my $query = new CGI;
my $file  = $query->param('channel');

# -- Multi day stuff
my $day   = $query->param('day');
$day = "0" unless defined($day);
$day =~ s/[^0-9]//g;

my @today    = localtime();
my @display  = @today;
my $dow      = $today[6];

$display[3] += $day;

my $title    = strftime("%A", @display);
$title  = "Today" if $day == 0;
$title .= "'s TV";

my $date     = strftime("%A, %B %e %Y", @display);
my $banner   = "";
for (my $i = 0; $i <= 6; $i++) {
    my @this  = @today;
    $this[3] += $i;
    my $foo   = strftime("%A", @this);

    if ($i == $day) {
        $banner .= "<b>$foo</b> : ";
    } else {
	$banner .= "<a href=\"channel.cgi?channel=$file&day=$i\">$foo</a> : ";
    }
}
$banner =~ s/ : $//;
# --------

print $query->header('text/html');
$file     =~ s/[^A-Za-z0-9_]//g;
my $fname = "$Telly::DATA/+$day/$file.pm";
&error() if (! $file) or (! -f $fname);

do "$fname";
my @chnl = @{ $Telly::LISTINGS{$file} };

my $time = (stat($fname))[9];
my $nice =  &Telly::niceChannelName($file);

print <<EOH;
<html>
<head>
<title>$title on $nice</title>

<style type="text/css"><!--
  body { margin:0px; }
  h1 {
    font-family: arial, helvetica, homerton, sans-serif;
    font-size: 160%;
  }

  .choice {
    font-family: arial, helvetica, homerton, sans-serif;
    font-size: 8pt;
  }

  .msg {
    font-family: times, trinity, serif;
    font-size: 75%;
    margin-left: 30%;
    text-align: right;
  }

  .subtitle {
    font-family: times, trinity, serif;
    font-size: 80%;
    font-weight: bold;
  }
--></style>

</head>

<body bgcolor="#ffffff" text="#000000" link="#0000FF" vlink="#008080"
alink="#00ff00" marginwidth=0 marginheight=0 style="margin:0px;">
<table border=0 cellspacing=0 cellpadding=8>
<tr bgcolor="#ffcc66"><td bgcolor="#ffd884" valign="middle" align="center"
class="subtitle"><a href="/tv/">UK TV Listings</a></td>
<td align="center">
<h1>$nice: $date</h1>
<small>$banner</small>
</td></tr>

<tr>
<td width="15%" bgcolor="#ffdd99" valign="top" class="choice">
<div class="choice">
<b><i>Channels:</i><br></b>
EOH
# ------------------------------------------------------------------------

foreach my $i (&Telly::channelList()) {
    print "&nbsp;*&nbsp;<a href=\"channel.cgi?channel=$i&day=$day\">";
    print &Telly::niceChannelName($i)."</a><br>\n";
}

# ------------------------------------------------------------------------
print <<EOH;
<br>&nbsp;<br>

<b><i>All Channels:</i><br></b>
&nbsp;*&nbsp;<a href="/cgi-bin/tv/all.cgi?desc=0&day=$day">Terrestrial (small)</a><br>
&nbsp;*&nbsp;<a href="/cgi-bin/tv/all.cgi?desc=1&day=$day">Terrestrial (big)</a><br>
</div></td>

<td width="85%" bgcolor="#fff0b0">
EOH
# ------------------------------------------------------------------------

my $fnt = '<font face="Arial,Helvetica,Homerton" size=2>';
print "<table cellpadding=0 cellspacing=3 border=0>";
foreach my $i (@chnl) {
    my ($time, $title, $desc) = @{ $i };

    my $bg = "";
    $bg = ' bgcolor="#dddddd"' if ($desc =~ m!\(Film\)!);

    print"<tr><td valign=\"top\">$fnt<b>".niceTime($time)."</b></font></td>\n";
    print"<td$bg>$fnt<b>$title</b> $desc</font></td></tr>\n";
}
print "</table>";

# ------------------------------------------------------------------------
print <<EOH;
</td>
</tr>
</table>
<p class="msg">&copy; Andrew Flegg 2000. All rights reserved.<br>
This content is sourced from publically available content on the
Internet.<br>
Please <a href="mailto:andrew\@bleb.org">send</a> any suggestions to me.
The original pages are at <a 
href="http://www.bleb.org/tv/">Bleb.org</a>.</p>
EOH
exit;

#-- Oops, die ---------------------------
sub error {
    print <<EOH;
You fscked up!
EOH

    exit;
}
