#!/usr/bin/perl -w
#
# (c) Andrew Flegg 2002. All rights reserved.

use strict;
use LWP::UserAgent;
use CGI;
$| = 1;


# -- Get a URL and store it to disk ------------------------------------
#
sub get {
    my ($url) = @_;
    my $ua = LWP::UserAgent->new( agent => "Mozilla/5.0 (i686; Linux)" );
    my $rq = HTTP::Request->new('GET', $url);
    my $rs = $ua->request($rq);
    #my $rs = $ua->get($url);

    return $rs->content if $rs->is_success();
    return '';
}


# -- Store a file to disk ----------------------------------------------
#
sub store {
    my ($file, $data) = @_;

    open(OUT, ">$file") or print STDERR "Unable to open $file: $!\n", return;
    print OUT $data;
    close(OUT) or print STDERR "Unable to close $file: $!\n", return;

    return;
}


# == MAIN ==============================================================
#
my $BASEHOST = 'http://www.ananova.com';
my $BASEURL  = '/tv_listings/tv_det.html?t=';
my $BASEDIR  = '/home/jaffa/bleb/tv/data/info';
my $QUERY    = new CGI;
my $id       = $QUERY->param('id');
$id =~ s/[^A-Za-z0-9]//g;

print $QUERY->header('text/html');
print "<b>No id specified</b>", exit unless $id;
#print "id = $id\n";

# -- Have we got a local copy already? -------------------------
#
if (-f "$BASEDIR/$id.html") {
    #print "Found $BASEDIR/$id.html, printing...\n";
    open(IN, "$BASEDIR/$id.html") or print "<b>Can't open $id</b>\n", exit;
    while (<IN>) { print }
    close(IN) or print "<b>Can't close $id.html</b>", exit;
    exit;
}

# -- Is this client allowed to fetch? --------------------------
#
my $ua = $ENV{'HTTP_USER_AGENT'} || '';
print "<b>Slurping info is denied, sorry</b>\n", exit if $ua =~ /(AvantGo|LinkChecker)/i;

# -- Need to fetch, munge and store ----------------------------
#
#print "Fetching $BASEHOST $BASEURL $id...\n";
my $data = get($BASEHOST.$BASEURL.$id);
#my $data = get('http://localhost/~andrew/tv_det.html');
print "<b>Unable to fetch data, try again later</b>\n", exit unless $data;

# -- Extract some interesting data...
#
$data =~ s/\r//g;
my ($prog) = $data =~ m!<img[^>]+src="[^>]+logos[^>]+"[^>]*>([^<>]+)!mi;
my ($day, $time, $channel) = $data =~ m!<font color="#990099"><br>\n\s*(\w+).*?(\d+:\d\d)\s*([^\()<>]+)!i;
$prog    =~ s/[\s:]+$//;
$day     =~ s/\s+$//;
$time    =~ s/\s+$//;
$channel =~ s/\s+$//;

# -- Manipulate the HTML...
#
$data =~ s!<(a|script)[^>]*>.*?</\1>!!gsi;
$data =~ s!<title>.*</title>!<title>$prog ($channel, $time $day)</title>!i;
$data =~ s!<(img|link|meta)[^>]+>!!gsi;
$data =~ s/\((To|Yester)day\)//gi;
$data =~ s/This (Mon|Tues|Wednes|Thurs|Fri|Satur|Sun)day/$1day/;

print $data;
store("$BASEDIR/$id.html", $data);
exit;
